<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!isNew"
    @submit="onSubmitHandler"
    :dropdown-menu="dropdownMenu"
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          :disabled="!isNew"
          v-model="formData.name"
          :label="dictionaryRu.modal.name"
          :placeholder="dictionaryRu.modal.name_placeholder"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          :disabled="!isNew"
          :label="dictionaryRu.modal.denomination"
          v-model="formData.denomination"
          :placeholder="dictionaryRu.modal.denomination_placeholder"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import FormValidationMixin   from 'common-components/src/obComponents/obForm/FormValidationMixin';
import models                from '@/models'
import cloneDeep             from 'clone-deep';
import ObForm                from 'common-components/src/obComponents/obForm';
import ObInput               from 'common-components/src/obComponents/obInput'
import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary }        from '@/translations/ru/dictionaries__services__services_list'

export default {
  name: 'ServiceUnit',
  components: { ObForm, ObInput },
  mixins: [
    FormValidationMixin
  ],
  props: {
    disabledForm: {
      type: Boolean,
      default: true
    },
    dataSource: {
      type: Object,
      required: true,
      default: () => {}
    }
  },
  data() {
    return {
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    }
  },
  computed: {
    formModel() {
      return models.serviceUnit.add;
    },
    isNew() {
      return !this.formData.uuid;
    },
    dropdownMenu() {
      return (this.isNew || this.dataSource.deleted_at) ? null : [
        {
          title: this.dictionaryRu.dropdown_menu.delete,
          className: 'color-error',
          method: () => {
            this.$emit('delete')
          }
        }
      ]
    }
  },
  methods: {
    onSubmitHandler() {
      const data = cloneDeep(this.formData);

      this.$emit('submit', { formData: data, model: this.formModel })
    }
  }
}
</script>
